]> git.saurik.com Git - apt.git/blob - test/integration/framework
eipp: let apt make a plan, not make stuff plane
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 elif [ "$1" = '--color=yes' ]; then
13 export MSGCOLOR='YES'
14 elif [ "$1" = '--color' ]; then
15 export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')"
16 shift
17 elif [ "$1" = '--level' ]; then
18 export MSGLEVEL=$2
19 shift
20 else
21 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
22 fi
23 shift
24 done
25 export MSGLEVEL="${MSGLEVEL:-3}"
26
27 # we all like colorful messages
28 if [ "${MSGCOLOR:-YES}" = 'YES' ]; then
29 if [ ! -t 1 ]; then # but check that we output to a terminal
30 export MSGCOLOR='NO'
31 fi
32 fi
33
34
35 if [ "$MSGCOLOR" != 'NO' ]; then
36 CERROR="\033[1;31m" # red
37 CWARNING="\033[1;33m" # yellow
38 CMSG="\033[1;32m" # green
39 CINFO="\033[1;96m" # light blue
40 CDEBUG="\033[1;94m" # blue
41 CNORMAL="\033[0;39m" # default system console color
42 CDONE="\033[1;32m" # green
43 CPASS="\033[1;32m" # green
44 CFAIL="\033[1;31m" # red
45 CCMD="\033[1;35m" # pink
46 fi
47
48 msgprintf() {
49 local START="$1"
50 local MIDDLE="$2"
51 local END="$3"
52 shift 3
53 if [ -n "$1" ]; then
54 printf "$START " "$1"
55 shift
56 while [ -n "$1" ]; do
57 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')"
58 shift
59 done
60 fi
61 printf "${END}"
62 }
63 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
64 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
65 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
66 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
67 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
68 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
69 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
70 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
71 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
72 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
73 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
74 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
75 msgreportheader() {
76 if [ -n "$MSGTEST_MSG" ]; then
77 test "$1" != 'msgfailoutput' || echo
78 if [ -n "$MSGTEST_MSGMSG" ]; then
79 echo "$MSGTEST_MSGMSG"
80 fi
81 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
82 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
83 fi
84 echo -n "$MSGTEST_MSG"
85 unset MSGTEST_MSG
86 fi
87 }
88 msgskip() {
89 msgreportheader 'msgskip'
90 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
91 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
92 }
93 msgfail() {
94 msgreportheader 'msgfail'
95 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
96 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
97 if [ -n "$APT_DEBUG_TESTS" ]; then
98 runapt $SHELL
99 fi
100 EXIT_CODE=$((EXIT_CODE+1));
101 }
102 MSGGROUP_LEVEL=0
103 msggroup() {
104 if [ -n "$1" ]; then
105 if [ $MSGGROUP_LEVEL = 0 ]; then
106 MSGTEST_GRP='NEXT'
107 fi
108 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
109 else
110 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
111 if [ $MSGGROUP_LEVEL = 0 ]; then
112 unset MSGTEST_GRP
113 fi
114 fi
115 }
116
117 # enable / disable Debugging
118 if [ $MSGLEVEL -le 0 ]; then
119 msgdie() { true; }
120 fi
121 if [ $MSGLEVEL -le 1 ]; then
122 msgwarn() { true; }
123 msgnwarn() { true; }
124 fi
125 if [ $MSGLEVEL -le 2 ]; then
126 msgmsg() {
127 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
128 }
129 msgnmsg() { true; }
130 msgtest() {
131 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
132 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
133 MSGTEST_GRP="$MSGTEST_MSG"
134 fi
135 }
136 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
137 fi
138 if [ $MSGLEVEL -le 3 ]; then
139 msginfo() { true; }
140 msgninfo() { true; }
141 fi
142 if [ $MSGLEVEL -le 4 ]; then
143 msgdebug() { true; }
144 msgndebug() { true; }
145 fi
146 msgdone() {
147 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
148 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
149 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
150 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
151 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
152 true;
153 else
154 printf "${CDONE}DONE${CNORMAL}\n";
155 fi
156 }
157 getaptconfig() {
158 if [ -f ./aptconfig.conf ]; then
159 echo "$(readlink -f ./aptconfig.conf)"
160 elif [ -f ../aptconfig.conf ]; then
161 echo "$(readlink -f ../aptconfig.conf)"
162 elif [ -f ../../aptconfig.conf ]; then
163 echo "$(readlink -f ../../aptconfig.conf)"
164 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
165 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
166 fi
167 }
168 runapt() {
169 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
170 local CMD="$1"
171 shift
172 case "$CMD" in
173 sh|aptitude|*/*|command) ;;
174 *) CMD="${BUILDDIRECTORY}/$CMD";;
175 esac
176 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@"
177 }
178 runpython3() { runapt command python3 "$@"; }
179 aptconfig() { runapt apt-config "$@"; }
180 aptcache() { runapt apt-cache "$@"; }
181 aptcdrom() { runapt apt-cdrom "$@"; }
182 aptget() { runapt apt-get "$@"; }
183 aptftparchive() { runapt apt-ftparchive "$@"; }
184 aptkey() { runapt apt-key "$@"; }
185 aptmark() { runapt apt-mark "$@"; }
186 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
187 apt() { runapt apt "$@"; }
188 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
189 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
190 aptitude() { runapt aptitude "$@"; }
191 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
192 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
193 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
194 aptinternalplanner() { runapt "${APTINTERNALPLANNER}" "$@"; }
195
196 dpkg() {
197 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
198 }
199 dpkgcheckbuilddeps() {
200 command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@"
201 }
202 gdb() {
203 local CMD
204 case "$1" in
205 aptget) CMD="apt-get";;
206 aptcache) CMD="apt-cache";;
207 aptcdrom) CMD="apt-cdrom";;
208 aptconfig) CMD="apt-config";;
209 aptmark) CMD="apt-mark";;
210 apthelper) CMD="apt-helper";;
211 aptftparchive) CMD="apt-ftparchive";;
212 dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;;
213 *) CMD="$1";;
214 esac
215 shift
216 if [ "${CMD##*/}" = "$CMD" ]; then
217 CMD="${BUILDDIRECTORY}/${CMD}"
218 fi
219 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
220 }
221 lastmodification() {
222 date -u -d "@$(stat -c '%Y' "${TMPWORKINGDIRECTORY}/$1")" '+%a, %d %b %Y %H:%M:%S GMT'
223 }
224 releasefiledate() {
225 grep "^${2:-Date}:" "$1" | cut -d' ' -f 2- | sed -e 's#UTC#GMT#'
226 }
227
228 exitwithstatus() {
229 # error if we about to overflow, but ...
230 # "255 failures ought to be enough for everybody"
231 if [ $EXIT_CODE -gt 255 ]; then
232 msgdie "Total failure count $EXIT_CODE too big"
233 fi
234 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
235 }
236
237 shellsetedetector() {
238 local exit_status=$?
239 if [ "$exit_status" != '0' ]; then
240 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
241 if [ "$EXIT_CODE" = '0' ]; then
242 EXIT_CODE="$exit_status"
243 fi
244 fi
245 }
246
247 addtrap() {
248 if [ "$1" = 'prefix' ]; then
249 CURRENTTRAP="$2 $CURRENTTRAP"
250 else
251 CURRENTTRAP="$CURRENTTRAP $1"
252 fi
253 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
254 }
255
256 escape_shell() {
257 echo "$@" | sed -e "s#'#'\"'\"'#g"
258 }
259
260 setupenvironment() {
261 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
262 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
263 unset TMPDIR
264 fi
265 TMPWORKINGDIRECTORY="$(mktemp -d)"
266 addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';"
267 if [ -n "$TMPDIR_ADD" ]; then
268 TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}"
269 mkdir -p "$TMPWORKINGDIRECTORY"
270 unset TMPDIR_ADD
271 export TMPDIR="$TMPWORKINGDIRECTORY"
272 fi
273 msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…"
274
275 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
276 if [ "$(id -u)" = '0' ]; then
277 # relax permissions so that running as root with user switching works
278 umask 022
279 chmod 711 "$TMPWORKINGDIRECTORY"
280 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
281 fi
282
283 TESTDIRECTORY="$(readlink -f "$(dirname $0)")"
284 # allow overriding the default BUILDDIR location
285 SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}"
286 BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}"
287 LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}"
288 METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}"
289 APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}"
290 APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}"
291 APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}"
292 APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}"
293 APTINTERNALPLANNER="${APT_INTEGRATION_TESTS_INTERNAL_PLANNER:-"${BUILDDIRECTORY}/apt-internal-planner"}"
294 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
295 # -----
296
297 cd "$TMPWORKINGDIRECTORY"
298 mkdir rootdir aptarchive keys
299 cd rootdir
300 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
301 mkdir -p usr/bin var/cache var/lib var/log tmp
302 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
303 touch var/lib/dpkg/available
304 mkdir -p usr/lib/apt
305 ln -s "${METHODSDIR}" usr/lib/apt/methods
306 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
307 mkdir -p usr/lib/apt/solvers usr/lib/apt/planners
308 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
309 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/planners/dump
310 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
311 ln -s "${BUILDDIRECTORY}/apt-internal-planner" usr/lib/apt/planners/apt
312 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" >> ../aptconfig.conf
313 echo "Dir::Bin::Planners \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/planners\";" >> ../aptconfig.conf
314 fi
315 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
316 # system
317 if [ -e "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" ]; then
318 ln -s "${BUILDDIRECTORY}/../../debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove
319 else
320 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
321 fi
322 cd ..
323 local BASENAME="${0##*/}"
324 local PACKAGESFILE="Packages-${BASENAME#*-}"
325 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
326 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
327 fi
328 local SOURCESSFILE="Sources-${BASENAME#*-}"
329 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
330 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
331 fi
332 find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \;
333 chmod 644 keys/*
334 ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
335
336 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
337 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
338 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
339 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
340 # either store apt-key were we can access it, even if we run it as a different user
341 #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
342 #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
343 #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
344 # destroys coverage reporting though, so we disable changing user for the calling gpgv
345 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
346 if [ "$(id -u)" = '0' ]; then
347 echo 'Binary::gpgv::APT::Sandbox::User "root";' >> aptconfig.conf
348 # same for the solver executables
349 echo 'APT::Solver::RunAsUser "root";' >> aptconfig.conf
350 echo 'APT::Planner::RunAsUser "root";' >> aptconfig.conf
351 fi
352
353 cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
354 #!/bin/sh
355 set -e
356 if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then
357 if [ -n "\$LD_LIBRARY_PATH" ]; then
358 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}"
359 else
360 export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}'
361 fi
362 if [ -n "\$LD_PRELOAD" ]; then
363 export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}"
364 else
365 export LD_PRELOAD="noopchroot.so"
366 fi
367 fi
368 EOF
369 cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
370 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF
371 exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
372 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
373 --force-not-root --force-bad-path "\$@"
374 EOF
375 cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF
376 exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\
377 --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\
378 --force-not-root --force-bad-path "\$@"
379 EOF
380 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
381 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
382
383 {
384 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
385 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
386 fi
387 echo 'quiet "0";'
388 echo 'quiet::NoUpdate "true";'
389 echo 'quiet::NoStatistic "true";'
390 # too distracting for users, but helpful to detect changes
391 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
392 echo 'Acquire::Progress::Diffpercent "true";'
393 # in testcases, it can appear as if localhost has a rotation setup,
394 # hide this as we can't really deal with it properly
395 echo 'Acquire::Failure::ShowIP "false";'
396 # fakeroot can't fake everything, so disabled in production but good for tests
397 echo 'APT::Sandbox::Verify "true";'
398 } >> aptconfig.conf
399
400 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
401 if [ "$(id -u)" = '0' ]; then
402 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
403 fi
404 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
405 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
406 echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig
407
408 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
409 confighashes 'SHA256' # these are tests, not security best-practices
410
411 # create some files in /tmp and look at user/group to get what this means
412 TEST_DEFAULT_USER="$(id -un)"
413 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
414 TEST_DEFAULT_GROUP='root'
415 else
416 TEST_DEFAULT_GROUP="$(id -gn)"
417 fi
418
419 # cleanup the environment a bit
420 # prefer our apt binaries over the system apt binaries
421 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
422 export LC_ALL=C.UTF-8
423 unset LANGUAGE APT_CONFIG
424 unset GREP_OPTIONS DEB_BUILD_PROFILES
425 unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy
426
427 # If gpgv supports --weak-digest, pass it to make sure we can disable SHA1
428 if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then
429 echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1
430 fi
431
432 # most tests just need one signed Release file, not both
433 export APT_DONT_SIGN='Release.gpg'
434
435 msgdone "info"
436 }
437
438 getarchitecture() {
439 if [ "$1" = "native" -o -z "$1" ]; then
440 eval `aptconfig shell ARCH APT::Architecture`
441 if [ -n "$ARCH" ]; then
442 echo $ARCH
443 else
444 dpkg --print-architecture
445 fi
446 else
447 echo $1
448 fi
449 }
450
451 getarchitectures() {
452 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
453 }
454
455 getarchitecturesfromcommalist() {
456 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
457 }
458
459 configarchitecture() {
460 {
461 echo "APT::Architecture \"$(getarchitecture $1)\";"
462 while [ -n "$1" ]; do
463 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
464 shift
465 done
466 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
467 configdpkg
468 }
469
470 configdpkg() {
471 if [ ! -e rootdir/var/lib/dpkg/status ]; then
472 local BASENAME="${0##*/}"
473 local STATUSFILE="status-${BASENAME#*-}"
474 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
475 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
476 else
477 echo -n > rootdir/var/lib/dpkg/status
478 fi
479 fi
480 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
481 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
482 local ARCHS="$(getarchitectures)"
483 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
484 DPKGARCH="$(dpkg --print-architecture)"
485 for ARCH in ${ARCHS}; do
486 if [ "${ARCH}" != "${DPKGARCH}" ]; then
487 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
488 # old-style used e.g. in Ubuntu-P – and as it seems travis
489 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
490 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
491 fi
492 fi
493 done
494 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
495 # dpkg doesn't really check the version as long as it is fully installed,
496 # but just to be sure we choose one above the required version
497 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
498 fi
499 fi
500 fi
501 }
502
503 configdpkgnoopchroot() {
504 # create a library to noop chroot() and rewrite maintainer script executions
505 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
506 # chroot directory dpkg could chroot into to execute the maintainer scripts
507 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
508 cat > noopchroot.c << EOF
509 #define _GNU_SOURCE
510 #include <stdio.h>
511 #include <stdlib.h>
512 #include <string.h>
513 #include <dlfcn.h>
514
515 static char * chrootdir = NULL;
516
517 int chroot(const char *path) {
518 printf("WARNING: CHROOTing to %s was ignored!\n", path);
519 free(chrootdir);
520 chrootdir = strdup(path);
521 return 0;
522 }
523 int execvp(const char *file, char *const argv[]) {
524 static int (*func_execvp) (const char *, char * const []) = NULL;
525 if (func_execvp == NULL)
526 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
527 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
528 return func_execvp(file, argv);
529 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
530 char *newfile;
531 if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) {
532 perror("asprintf");
533 return -1;
534 }
535 char const * const baseadmindir = "/var/lib/dpkg";
536 char *admindir;
537 if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) {
538 perror("asprintf");
539 return -1;
540 }
541 setenv("DPKG_ADMINDIR", admindir, 1);
542 return func_execvp(newfile, argv);
543 }
544 EOF
545 testempty --nomsg gcc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl
546 }
547 configcompression() {
548 if [ "$1" = 'ALL' ]; then
549 configcompression '.' $(aptconfig dump APT::Compressor --format '%t %v%n' | sed -n 's#^Extension \.\(.*\)$#\1#p')
550 return
551 fi
552 local CMD='apthelper cat-file -C'
553 while [ -n "$1" ]; do
554 case "$1" in
555 '.') printf ".\t.\tcat\n";;
556 'gz') printf "gzip\tgz\t$CMD $1\n";;
557 'bz2') printf "bzip2\tbz2\t$CMD $1\n";;
558 *) printf "$1\t$1\t$CMD $1\n";;
559 esac
560 shift
561 done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
562 }
563 confighashes() {
564 {
565 echo 'APT::FTPArchive {'
566 {
567 while [ -n "$1" ]; do
568 printf "$1" | tr 'a-z' 'A-Z'
569 printf "\t\"true\";\n"
570 shift
571 done
572 for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do
573 printf "$h\t\"false\";\n"
574 done
575 } | awk '!x[$1]++'
576 echo '};'
577 } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf"
578 }
579 forcecompressor() {
580 COMPRESSOR="$1"
581 COMPRESS="$1"
582 COMPRESSOR_CMD="apthelper cat-file -C $1"
583 case $COMPRESSOR in
584 gzip) COMPRESS='gz';;
585 bzip2) COMPRESS='bz2';;
586 esac
587 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
588 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
589 Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE"
590 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
591 if [ -z "$COMP" -o "$COMP" = '.' -o "$COMP" = "$COMPRESSOR" ]; then continue; fi
592 echo "Dir::Bin::${COMP} \"/does/not/exist\";" >> "$CONFFILE"
593 echo "APT::Compressor::${COMP}::Name \"${COMP}-disabled\";" >> "$CONFFILE"
594 done
595 }
596
597 setupsimplenativepackage() {
598 local NAME="$1"
599 local ARCH="$2"
600 local VERSION="$3"
601 local RELEASE="${4:-unstable}"
602 local DEPENDENCIES="$5"
603 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
604 If you find such a package installed on your system,
605 something went horribly wrong! They are autogenerated
606 und used only by testcases and serve no other purpose…"}"
607
608 local SECTION="${7:-others}"
609 local DISTSECTION
610 if [ "$SECTION" = "${SECTION#*/}" ]; then
611 DISTSECTION="main"
612 else
613 DISTSECTION="${SECTION%/*}"
614 fi
615 local BUILDDIR=incoming/${NAME}-${VERSION}
616 mkdir -p ${BUILDDIR}/debian/source
617 cd ${BUILDDIR}
618 echo "* most suckless software product ever" > FEATURES
619 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date -u +%Y)" > debian/copyright
620 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
621
622 * Initial release
623
624 -- Joe Sixpack <joe@example.org> $(date -u -R)" > debian/changelog
625 test -e debian/control || echo "Source: $NAME
626 Section: $SECTION
627 Priority: optional
628 Maintainer: Joe Sixpack <joe@example.org>
629 Build-Depends: debhelper (>= 7)
630 Standards-Version: 3.9.1
631
632 Package: $NAME" > debian/control
633 if [ "$ARCH" = 'all' ]; then
634 echo "Architecture: all" >> debian/control
635 else
636 echo "Architecture: any" >> debian/control
637 fi
638 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
639 echo "Description: $DESCRIPTION" >> debian/control
640
641 test -e debian/compat || echo "7" > debian/compat
642 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
643 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
644 cd - > /dev/null
645 }
646
647 buildsimplenativepackage() {
648 local NAME="$1"
649 local NM
650 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
651 NM="$(echo "$NAME" | cut -c 1-4)"
652 else
653 NM="$(echo "$NAME" | cut -c 1)"
654 fi
655 local ARCH="$2"
656 local VERSION="$3"
657 local RELEASE="${4:-unstable}"
658 local DEPENDENCIES="$5"
659 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
660 If you find such a package installed on your system,
661 something went horribly wrong! They are autogenerated
662 und used only by testcases and serve no other purpose…"}"
663
664 local SECTION="${7:-others}"
665 local PRIORITY="${8:-optional}"
666 local FILE_TREE="$9"
667 local COMPRESS_TYPE="${10:-gzip}"
668 local DISTSECTION
669 if [ "$SECTION" = "${SECTION#*/}" ]; then
670 DISTSECTION="main"
671 else
672 DISTSECTION="${SECTION%/*}"
673 fi
674 local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}"
675
676 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
677 mkdir -p "$BUILDDIR/debian/source"
678 echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES"
679 echo "#!/bin/sh
680 echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}"
681
682 echo "Copyleft by Joe Sixpack $(date -u +%Y)" > "${BUILDDIR}/debian/copyright"
683 echo "$NAME ($VERSION) $RELEASE; urgency=low
684
685 * Initial release
686
687 -- Joe Sixpack <joe@example.org> $(date -u -R)" > "${BUILDDIR}/debian/changelog"
688 {
689 echo "Source: $NAME
690 Priority: $PRIORITY
691 Maintainer: Joe Sixpack <joe@example.org>
692 Standards-Version: 3.9.3"
693 if [ "$SECTION" != '<none>' ]; then
694 echo "Section: $SECTION"
695 fi
696 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
697 test -z "$BUILDDEPS" || echo "$BUILDDEPS"
698 echo "
699 Package: $NAME"
700
701 if [ "$ARCH" = 'all' ]; then
702 echo "Architecture: all"
703 else
704 echo "Architecture: any"
705 fi
706 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
707 test -z "$DEPS" || echo "$DEPS"
708 echo "Description: $DESCRIPTION"
709 } > "${BUILDDIR}/debian/control"
710
711 echo '3.0 (native)' > "${BUILDDIR}/debian/source/format"
712 cd "${BUILDDIR}/.."
713 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
714 cd - >/dev/null
715 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \
716 | while read SRC; do
717 echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist"
718 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
719 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
720 # adv --yes --default-key 'Joe Sixpack' \
721 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
722 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
723 # fi
724 done
725
726 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
727 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
728 rm -rf "${BUILDDIR}/debian/tmp"
729 mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin"
730 cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}"
731 cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}"
732 if [ -n "$FILE_TREE" ]; then
733 cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp"
734 fi
735
736 (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch)
737 (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
738 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
739 # ensure the right permissions as dpkg-deb insists
740 chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN"
741 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.."
742 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist"
743 done
744
745 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
746 mkdir -p "$CHANGEPATH"
747 cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH"
748 rm -rf "${BUILDDIR}"
749 msgdone "info"
750 }
751
752 buildpackage() {
753 local BUILDDIR=$1
754 local RELEASE=$2
755 local SECTION=$3
756 local ARCH=$(getarchitecture $4)
757 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
758 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
759 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
760 cd "$BUILDDIR"
761 if [ "$ARCH" = "all" ]; then
762 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
763 fi
764 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
765 cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG"
766 local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")"
767 local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')"
768 cd - > /dev/null
769 for PKG in $PKGS; do
770 echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist"
771 done
772 for SRC in $SRCS; do
773 echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist"
774 done
775 }
776
777 buildaptarchive() {
778 if [ -d incoming ]; then
779 buildaptarchivefromincoming "$@"
780 else
781 buildaptarchivefromfiles "$@"
782 fi
783 }
784
785 createaptftparchiveconfig() {
786 local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')"
787 local COMPRESSORS="${COMPRESSORS%* }"
788 local ARCHS="$(getarchitectures)"
789 cat > ftparchive.conf <<EOF
790 Dir {
791 ArchiveDir "$(readlink -f .)";
792 CacheDir "$(readlink -f ..)";
793 FileListDir "$(readlink -f pool/)";
794 };
795 Default {
796 Packages::Compress "$COMPRESSORS";
797 Sources::Compress "$COMPRESSORS";
798 Contents::Compress "$COMPRESSORS";
799 Translation::Compress "$COMPRESSORS";
800 LongDescription "false";
801 };
802 TreeDefault {
803 Directory "pool/";
804 SrcDirectory "pool/";
805 };
806 EOF
807 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
808 cat <<EOF
809 tree "dists/$DIST" {
810 Architectures "$ARCHS all source";
811 FileList "${DIST}.\$(SECTION).pkglist";
812 SourceFileList "${DIST}.\$(SECTION).srclist";
813 Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')";
814 };
815 EOF
816 done >> ftparchive.conf
817 }
818
819 buildaptftparchivedirectorystructure() {
820 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
821 for DIST in $DISTS; do
822 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
823 for SECTION in $SECTIONS; do
824 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
825 for ARCH in $ARCHS; do
826 mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}"
827 done
828 mkdir -p "dists/${DIST}/${SECTION}/source"
829 mkdir -p "dists/${DIST}/${SECTION}/i18n"
830 done
831 done
832 }
833
834 insertpackage() {
835 local RELEASES="$1"
836 local NAME="$2"
837 local ARCH="$3"
838 local VERSION="$4"
839 local DEPENDENCIES="$5"
840 local PRIORITY="${6:-optional}"
841 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
842 If you find such a package installed on your system,
843 something went horribly wrong! They are autogenerated
844 und used only by testcases and serve no other purpose…"}"
845 local ARCHS=""
846 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
847 if [ "$RELEASE" = 'installed' ]; then
848 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
849 continue
850 fi
851 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
852 if [ "$arch" = 'none' ]; then
853 ARCHS="$(getarchitectures)"
854 else
855 ARCHS="$arch"
856 fi
857 for BUILDARCH in $ARCHS; do
858 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
859 mkdir -p "$PPATH"
860 {
861 echo "Package: $NAME
862 Priority: $PRIORITY
863 Section: other
864 Installed-Size: 42
865 Maintainer: Joe Sixpack <joe@example.org>"
866 test "$arch" = 'none' || echo "Architecture: $arch"
867 echo "Version: $VERSION
868 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb"
869 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES"
870 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)"
871 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)"
872 echo
873 } >> "${PPATH}/Packages"
874 done
875 done
876 mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n"
877 touch "aptarchive/dists/${RELEASE}/main/source/Sources"
878 echo "Package: $NAME
879 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
880 Description-en: $DESCRIPTION
881 " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en"
882 done
883 }
884
885 insertsource() {
886 local RELEASES="$1"
887 local NAME="$2"
888 local ARCH="$3"
889 local VERSION="$4"
890 local DEPENDENCIES="$5"
891 local BINARY="${6:-$NAME}"
892 local ARCHS=""
893 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
894 local SPATH="aptarchive/dists/${RELEASE}/main/source"
895 mkdir -p $SPATH
896 local FILE="${SPATH}/Sources"
897 local DSCFILE="${NAME}_${VERSION}.dsc"
898 local TARFILE="${NAME}_${VERSION}.tar.gz"
899 echo "Package: $NAME
900 Binary: $BINARY
901 Version: $VERSION
902 Maintainer: Joe Sixpack <joe@example.org>
903 Architecture: $ARCH" >> $FILE
904 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
905 echo "Files:
906 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
907 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
908 Checksums-Sha256:
909 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE"
910 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE"
911 " >> "$FILE"
912 done
913 }
914
915 insertinstalledpackage() {
916 local NAME="$1"
917 local ARCH="$2"
918 local VERSION="$3"
919 local DEPENDENCIES="$4"
920 local PRIORITY="${5:-optional}"
921 local STATUS="${6:-install ok installed}"
922 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
923 If you find such a package installed on your system,
924 something went horribly wrong! They are autogenerated
925 und used only by testcases and serve no other purpose…"}"
926
927 local FILE='rootdir/var/lib/dpkg/status'
928 local INFO='rootdir/var/lib/dpkg/info'
929 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
930 echo "Package: $NAME
931 Status: $STATUS
932 Priority: $PRIORITY
933 Section: other
934 Installed-Size: 42
935 Maintainer: Joe Sixpack <joe@example.org>
936 Version: $VERSION" >> "$FILE"
937 test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE"
938 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE"
939 echo "Description: $DESCRIPTION" >> "$FILE"
940 echo >> "$FILE"
941 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
942 echo -n > "${INFO}/${NAME}:${arch}.list"
943 else
944 echo -n > "${INFO}/${NAME}.list"
945 fi
946 done
947 }
948
949
950 buildaptarchivefromincoming() {
951 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…"
952 cd aptarchive
953 [ -e pool ] || ln -s ../incoming pool
954 [ -e ftparchive.conf ] || createaptftparchiveconfig
955 [ -e dists ] || buildaptftparchivedirectorystructure
956 msgninfo "\tGenerate Packages, Sources and Contents files… "
957 testsuccess aptftparchive generate ftparchive.conf
958 cd - > /dev/null
959 msgdone "info"
960 generatereleasefiles "$@"
961 }
962
963 buildaptarchivefromfiles() {
964 msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…"
965 local DIR='aptarchive'
966 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
967 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
968 msgninfo "\t${line} file"
969 compressfile "$line" "$1"
970 msgdone "info"
971 done
972 generatereleasefiles "$@"
973 }
974
975 compressfile() {
976 while read compressor extension command; do
977 if [ "$compressor" = '.' ]; then
978 if [ -n "$2" ]; then
979 touch -d "$2" "$1"
980 fi
981 continue
982 fi
983 cat "$1" | $command > "${1}.${extension}"
984 if [ -n "$2" ]; then
985 touch -d "$2" "${1}.${extension}"
986 fi
987 done < "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf"
988 }
989
990 # can be overridden by testcases for their pleasure
991 getcodenamefromsuite() {
992 case "$1" in
993 unstable) echo 'sid';;
994 *) echo -n "$1";;
995 esac
996 }
997 getreleaseversionfromsuite() { true; }
998 getlabelfromsuite() { true; }
999 getoriginfromsuite() { true; }
1000 getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; }
1001
1002 aptftparchiverelease() {
1003 aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference
1004 }
1005 generatereleasefiles() {
1006 # $1 is the Date header and $2 is the ValidUntil header to be set
1007 # both should be given in notation date/touch can understand
1008 local DATE="$1"
1009 local VALIDUNTIL="$2"
1010 if [ -e aptarchive/dists ]; then
1011 msgninfo "\tGenerate Release files for dists… "
1012 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
1013 local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")"
1014 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
1015 local CODENAME="$(getcodenamefromsuite $SUITE)"
1016 local VERSION="$(getreleaseversionfromsuite $SUITE)"
1017 local LABEL="$(getlabelfromsuite $SUITE)"
1018 local ORIGIN="$(getoriginfromsuite $SUITE)"
1019 aptftparchiverelease "$dir" \
1020 -o APT::FTPArchive::Release::Suite="${SUITE}" \
1021 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
1022 -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \
1023 -o APT::FTPArchive::Release::Label="${LABEL}" \
1024 -o APT::FTPArchive::Release::Origin="${ORIGIN}" \
1025 -o APT::FTPArchive::Release::Version="${VERSION}" \
1026 > "$dir/Release"
1027 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
1028 sed -i '/^Date: / a\
1029 NotAutomatic: yes' "$dir/Release"
1030 fi
1031 done
1032 else
1033 msgninfo "\tGenerate Release files for flat… "
1034 aptftparchiverelease ./aptarchive > aptarchive/Release
1035 fi
1036 if [ -n "$DATE" -a "$DATE" != "now" ]; then
1037 for release in $(find ./aptarchive -name 'Release'); do
1038 sed -i "s/^Date: .*$/Date: $(date -u -d "$DATE" '+%a, %d %b %Y %H:%M:%S %Z')/" "$release"
1039 touch -d "$DATE" "$release"
1040 done
1041 fi
1042 if [ -n "$VALIDUNTIL" ]; then
1043 sed -i "/^Date: / a\
1044 Valid-Until: $(date -u -d "$VALIDUNTIL" '+%a, %d %b %Y %H:%M:%S %Z')" $(find ./aptarchive -name 'Release')
1045 fi
1046 msgdone "info"
1047 }
1048
1049 setupdistsaptarchive() {
1050 local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1051 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1052 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1053 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
1054 SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1055 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}"
1056 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list"
1057 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list"
1058 msgdone "info"
1059 done
1060 }
1061
1062 setupflataptarchive() {
1063 local APTARCHIVE="$(readlink -f ./aptarchive)"
1064 local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')"
1065 if [ -f "${APTARCHIVE}/Packages" ]; then
1066 msgninfo "\tadd deb sources.list line… "
1067 echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1068 msgdone 'info'
1069 else
1070 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list'
1071 fi
1072 if [ -f "${APTARCHIVE}/Sources" ]; then
1073 msgninfo "\tadd deb-src sources.list line… "
1074 echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1075 msgdone 'info'
1076 else
1077 rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list'
1078 fi
1079 }
1080
1081 setupaptarchive() {
1082 local NOUPDATE=0
1083 if [ "$1" = '--no-update' ]; then
1084 NOUPDATE=1
1085 shift
1086 fi
1087 buildaptarchive "$@"
1088 if [ -e aptarchive/dists ]; then
1089 setupdistsaptarchive
1090 else
1091 setupflataptarchive
1092 fi
1093 signreleasefiles 'Joe Sixpack'
1094 if [ "1" != "$NOUPDATE" ]; then
1095 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
1096 fi
1097 }
1098
1099 signreleasefiles() {
1100 local SIGNERS="${1:-Joe Sixpack}"
1101 local REPODIR="${2:-aptarchive}"
1102 if [ -n "$1" ]; then shift; fi
1103 if [ -n "$1" ]; then shift; fi
1104 local KEY="keys/$(echo "$SIGNERS" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1105 msgninfo "\tSign archive with $SIGNERS key $KEY"
1106 local REXKEY='keys/rexexpired'
1107 local SECEXPIREBAK="${REXKEY}.sec.bak"
1108 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1109 local SIGUSERS=""
1110 while [ -n "${SIGNERS%%,*}" ]; do
1111 local SIGNER="${SIGNERS%%,*}"
1112 if [ "${SIGNERS}" = "${SIGNER}" ]; then
1113 SIGNERS=""
1114 fi
1115 SIGNERS="${SIGNERS#*,}"
1116 # FIXME: This should be the full name, but we can't encode the space properly currently
1117 SIGUSERS="${SIGUSERS} -u ${SIGNER#* }"
1118 if [ "${SIGNER}" = 'Rex Expired' ]; then
1119 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1120 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1121 # therefore we 'temporary' make the key not expired and restore a backup after signing
1122 cp "${REXKEY}.sec" "$SECEXPIREBAK"
1123 cp "${REXKEY}.pub" "$PUBEXPIREBAK"
1124 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1125 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1126 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1127 cp "$SECUNEXPIRED" "${REXKEY}.sec"
1128 cp "$PUBUNEXPIRED" "${REXKEY}.pub"
1129 else
1130 if ! printf "expire\n1w\nsave\n" | aptkey --quiet --keyring "${REXKEY}.pub" --secret-keyring "${REXKEY}.sec" \
1131 --readonly adv --batch --yes --digest-algo "${APT_TESTS_DIGEST_ALGO:-SHA512}" \
1132 --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1133 cat setexpire.gpg
1134 exit 1
1135 fi
1136 cp "${REXKEY}.sec" "$SECUNEXPIRED"
1137 cp "${REXKEY}.pub" "$PUBUNEXPIRED"
1138 fi
1139 fi
1140 if [ ! -e "${KEY}.pub" ]; then
1141 local K="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | tr -d ' ,')"
1142 cat "${K}.pub" >> "${KEY}.new.pub"
1143 cat "${K}.sec" >> "${KEY}.new.sec"
1144 fi
1145 done
1146 if [ ! -e "${KEY}.pub" ]; then
1147 mv "${KEY}.new.pub" "${KEY}.pub"
1148 mv "${KEY}.new.sec" "${KEY}.sec"
1149 fi
1150 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo ${APT_TESTS_DIGEST_ALGO:-SHA512}"
1151 for RELEASE in $(find "${REPODIR}/" -name Release); do
1152 # we might have set a specific date for the Release file, so copy it
1153 local DATE="$(stat --format "%y" "${RELEASE}")"
1154 if [ "$APT_DONT_SIGN" = 'Release.gpg' ]; then
1155 rm -f "${RELEASE}.gpg"
1156 else
1157 testsuccess $GPG "$@" $SIGUSERS --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}"
1158 touch -d "$DATE" "${RELEASE}.gpg"
1159 fi
1160 local INRELEASE="${RELEASE%/*}/InRelease"
1161 if [ "$APT_DONT_SIGN" = 'InRelease' ]; then
1162 rm -f "$INRELEASE"
1163 else
1164 testsuccess $GPG "$@" $SIGUSERS --clearsign --output "$INRELEASE" "$RELEASE"
1165 touch -d "$DATE" "${INRELEASE}"
1166 fi
1167 done
1168 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1169 mv -f "$SECEXPIREBAK" "${REXKEY}.sec"
1170 mv -f "$PUBEXPIREBAK" "${REXKEY}.pub"
1171 fi
1172 msgdone 'info'
1173 }
1174
1175 redatereleasefiles() {
1176 local DATE="$(date -u -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1177 for release in $(find aptarchive/ -name 'Release'); do
1178 sed -i "s/^Date: .*$/Date: ${DATE}/" "$release"
1179 touch -d "$DATE" "$release"
1180 done
1181 signreleasefiles "${2:-Joe Sixpack}"
1182 }
1183
1184 webserverconfig() {
1185 local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}"
1186 local NOCHECK=false
1187 if [ "$1" = '--no-check' ]; then
1188 NOCHECK=true
1189 shift
1190 fi
1191 local DOWNLOG='rootdir/tmp/download-testfile.log'
1192 local STATUS='downloaded/webserverconfig.status'
1193 rm -f "$STATUS" "$DOWNLOG"
1194 # very very basic URI encoding
1195 local URI
1196 if [ -n "$2" ]; then
1197 msgtest "Set webserver config option '${1}' to" "$2"
1198 URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')"
1199 else
1200 msgtest 'Clear webserver config option' "${1}"
1201 URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')"
1202 fi
1203 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1204 msgpass
1205 else
1206 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1207 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1208 msgfailoutput '' "$OUTPUT"
1209 fi
1210 $NOCHECK || testwebserverlaststatuscode '200'
1211 }
1212
1213 rewritesourceslist() {
1214 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1215 local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')"
1216 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1217 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \
1218 -e "s#http://[^@]*@\?localhost:${APTHTTPPORT}/\?#${1}#" \
1219 -e "s#https://[^@]*@\?localhost:${APTHTTPSPORT}/\?#${1}#"
1220 done
1221 }
1222
1223 # wait for up to 10s for a pid file to appear to avoid possible race
1224 # when a helper is started and dosn't write the PID quick enough
1225 waitforpidfile() {
1226 local PIDFILE="$1"
1227 for i in $(seq 10); do
1228 if test -s "$PIDFILE"; then
1229 return 0
1230 fi
1231 sleep 1
1232 done
1233 msgdie "waiting for $PIDFILE failed"
1234 return 1
1235 }
1236
1237 changetowebserver() {
1238 local REWRITE='no'
1239 if [ "$1" != '--no-rewrite' ]; then
1240 REWRITE='yes'
1241 else
1242 shift
1243 fi
1244 if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then
1245 cd aptarchive
1246 local LOG="webserver.log"
1247 if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then
1248 cat "$LOG"
1249 false
1250 fi
1251 waitforpidfile aptwebserver.pid
1252 local PID="$(cat aptwebserver.pid)"
1253 if [ -z "$PID" ]; then
1254 msgdie 'Could not fork aptwebserver successfully'
1255 fi
1256 addtrap "kill $PID;"
1257 waitforpidfile aptwebserver.port
1258 APTHTTPPORT="$(cat aptwebserver.port)"
1259 if [ -z "$APTHTTPPORT" ]; then
1260 msgdie 'Could not get port for aptwebserver successfully'
1261 fi
1262 cd - > /dev/null
1263 else
1264 msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver'
1265 fi
1266 if [ "$REWRTE" != 'yes' ]; then
1267 rewritesourceslist "http://localhost:${APTHTTPPORT}/"
1268 fi
1269 }
1270
1271 changetohttpswebserver() {
1272 if ! command -v stunnel4 >/dev/null 2>&1; then
1273 msgdie 'You need to install stunnel4 for https testcases'
1274 fi
1275 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1276 changetowebserver --no-rewrite "$@"
1277 fi
1278 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1279 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1280 output = /dev/null
1281
1282 [https]
1283 accept = 0
1284 connect = $APTHTTPPORT
1285 " > "${TMPWORKINGDIRECTORY}/stunnel.conf"
1286 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1287 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1288 local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")"
1289 if [ -z "$PID" ]; then
1290 msgdie 'Could not fork stunnel4 successfully'
1291 fi
1292 addtrap 'prefix' "kill ${PID};"
1293 APTHTTPSPORT="$(lsof -i -n | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)"
1294 webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}"
1295 rewritesourceslist "https://localhost:${APTHTTPSPORT}/"
1296 }
1297
1298 changetocdrom() {
1299 mkdir -p rootdir/media/cdrom/.disk
1300 local CD="$(readlink -f rootdir/media/cdrom)"
1301 cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF
1302 acquire::cdrom::mount "${CD}";
1303 acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}";
1304 acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted";
1305 acquire::cdrom::autodetect 0;
1306 EOF
1307 echo -n "$1" > "${CD}/.disk/info"
1308 if [ ! -d aptarchive/dists ]; then
1309 msgdie 'Flat file archive cdroms can not be created currently'
1310 return 1
1311 fi
1312 mv aptarchive/dists "$CD"
1313 ln -s "$(readlink -f ./incoming)" "$CD/pool"
1314 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1315 # start with an unmounted disk
1316 mv "${CD}" "${CD}-unmounted"
1317 # we don't want the disk to be modifiable
1318 addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;"
1319 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1320 }
1321
1322 downloadfile() {
1323 local PROTO="${1%%:*}"
1324 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1325 download-file "$1" "$2" "$3" 2>&1 ; then
1326 return 1
1327 fi
1328 # only if the file exists the download was successful
1329 if [ -r "$2" ]; then
1330 return 0
1331 else
1332 return 1
1333 fi
1334 }
1335
1336 checkdiff() {
1337 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1338 if [ -n "$DIFFTEXT" ]; then
1339 echo >&2
1340 echo >&2 "$DIFFTEXT"
1341 return 1
1342 else
1343 return 0
1344 fi
1345 }
1346
1347 testoutputequal() {
1348 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1349 local COMPAREFILE="$1"
1350 shift
1351 if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
1352 msgpass
1353 else
1354 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1355 cat "$COMPAREFILE" >>"${OUTPUT}"
1356 msgfailoutput '' "$OUTPUT" "$@"
1357 fi
1358 }
1359
1360 testfileequal() {
1361 msggroup 'testfileequal'
1362 local MSG='Test for correctness of file'
1363 if [ "$1" = '--nomsg' ]; then
1364 MSG=''
1365 shift
1366 fi
1367 local FILE="$1"
1368 shift
1369 if [ -n "$MSG" ]; then
1370 msgtest "$MSG" "$FILE"
1371 fi
1372 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
1373 if [ -z "$*" ]; then
1374 testoutputequal "$FILE" echo -n ''
1375 else
1376 testoutputequal "$FILE" echo "$*"
1377 fi
1378 msggroup
1379 }
1380
1381 testempty() {
1382 msggroup 'testempty'
1383 if [ "$1" = '--nomsg' ]; then
1384 shift
1385 else
1386 msgtest "Test for no output of" "$*"
1387 fi
1388 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1389 if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then
1390 msgpass
1391 else
1392 msgfailoutput '' "$COMPAREFILE" "$@"
1393 fi
1394 aptautotest 'testempty' "$@"
1395 msggroup
1396 }
1397 testnotempty() {
1398 msggroup 'testnotempty'
1399 msgtest "Test for some output of" "$*"
1400 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile"
1401 if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then
1402 msgpass
1403 else
1404 msgfailoutput '' "$COMPAREFILE" "$@"
1405 fi
1406 aptautotest 'testnotempty' "$@"
1407 msggroup
1408 }
1409
1410 testequal() {
1411 msggroup 'testequal'
1412 local MSG='Test of equality of'
1413 if [ "$1" = '--nomsg' ]; then
1414 MSG=''
1415 shift
1416 fi
1417
1418 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1419 echo "$1" > "$COMPAREFILE"
1420 shift
1421
1422 if [ -n "$MSG" ]; then
1423 msgtest "$MSG" "$*"
1424 fi
1425 testoutputequal "$COMPAREFILE" "$@"
1426 aptautotest 'testequal' "$@"
1427 msggroup
1428 }
1429
1430 testequalor2() {
1431 msggroup 'testequalor2'
1432 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1433 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1434 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1435 echo "$1" > "$COMPAREFILE1"
1436 echo "$2" > "$COMPAREFILE2"
1437 shift 2
1438 msgtest "Test for equality OR of" "$*"
1439 "$@" >"$COMPAREAGAINST" 2>&1 || true
1440 if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \
1441 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1
1442 then
1443 msgpass
1444 else
1445 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1446 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1447 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1448 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1449 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1450 msgfailoutput '' "$OUTPUT"
1451 fi
1452 aptautotest 'testequalor2' "$@"
1453 msggroup
1454 }
1455
1456 testshowvirtual() {
1457 msggroup 'testshowvirtual'
1458 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1459 local PACKAGE="$1"
1460 shift
1461 while [ -n "$1" ]; do
1462 VIRTUAL="${VIRTUAL}
1463 N: Can't select versions from package '$1' as it is purely virtual"
1464 PACKAGE="${PACKAGE} $1"
1465 shift
1466 done
1467 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1468 VIRTUAL="${VIRTUAL}
1469 N: No packages found"
1470 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1471 local ARCH="$(getarchitecture 'native')"
1472 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1473 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
1474 testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE"
1475 msggroup
1476 }
1477
1478 testnopackage() {
1479 msggroup 'testnopackage'
1480 msgtest "Test for non-existent packages" "apt-cache show $*"
1481 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1482 if [ -n "$SHOWPKG" ]; then
1483 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1484 echo "$SHOWPKG" >"$OUTPUT"
1485 msgfailoutput '' "$OUTPUT"
1486 else
1487 msgpass
1488 fi
1489 msggroup
1490 }
1491 testnosrcpackage() {
1492 msggroup 'testnosrcpackage'
1493 msgtest "Test for non-existent source packages" "apt-cache showsrc $*"
1494 local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')"
1495 if [ -n "$SHOWPKG" ]; then
1496 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output"
1497 echo "$SHOWPKG" >"$OUTPUT"
1498 msgfailoutput '' "$OUTPUT"
1499 else
1500 msgpass
1501 fi
1502 msggroup
1503 }
1504
1505 testdpkgstatus() {
1506 msggroup 'testdpkgstatus'
1507 local STATE="$1"
1508 local NR="$2"
1509 shift 2
1510 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1511 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1512 if [ "$PKGS" != $NR ]; then
1513 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1514 echo "$PKGS" >"$OUTPUT"
1515 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1516 msgfailoutput '' "$OUTPUT"
1517 else
1518 msgpass
1519 fi
1520 msggroup
1521 }
1522
1523 testdpkginstalled() {
1524 msggroup 'testdpkginstalled'
1525 testdpkgstatus 'ii' "$#" "$@"
1526 msggroup
1527 }
1528
1529 testdpkgnotinstalled() {
1530 msggroup 'testdpkgnotinstalled'
1531 testdpkgstatus 'ii' '0' "$@"
1532 msggroup
1533 }
1534
1535 testmarkedauto() {
1536 msggroup 'testmarkedauto'
1537 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1538 if [ -n "$1" ]; then
1539 msgtest 'Test for correctly marked as auto-installed' "$*"
1540 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1541 else
1542 msgtest 'Test for correctly marked as auto-installed' 'no package'
1543 echo -n > "$COMPAREFILE"
1544 fi
1545 testoutputequal "$COMPAREFILE" aptmark showauto
1546 msggroup
1547 }
1548 testmarkedmanual() {
1549 msggroup 'testmarkedmanual'
1550 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1551 if [ -n "$1" ]; then
1552 msgtest 'Test for correctly marked as manually installed' "$*"
1553 while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE"
1554 else
1555 msgtest 'Test for correctly marked as manually installed' 'no package'
1556 echo -n > "$COMPAREFILE"
1557 fi
1558 testoutputequal "$COMPAREFILE" aptmark showmanual
1559 msggroup
1560 }
1561
1562 catfile() {
1563 if [ "${1##*.}" = 'deb' ]; then
1564 stat >&2 "$1" || true
1565 file >&2 "$1" || true
1566 else
1567 cat >&2 "$1" || true
1568 fi
1569 }
1570 msgfailoutput() {
1571 msgreportheader 'msgfailoutput'
1572 local MSG="$1"
1573 local OUTPUT="$2"
1574 shift 2
1575 local CMD="$1"
1576 if [ "$1" = 'grep' -o "$1" = 'tail' -o "$1" = 'head' ]; then
1577 echo >&2
1578 while [ -n "$2" ]; do shift; done
1579 echo "#### Complete file: $1 ####"
1580 catfile "$1"
1581 echo "#### $CMD output ####"
1582 elif [ "$1" = 'test' ]; then
1583 echo >&2
1584 # doesn't support ! or non-file flags
1585 msgfailoutputstatfile() {
1586 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1587 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1588 echo "#### stat(2) of file: $2 ####"
1589 stat "$2" || true
1590 if test -d "$2"; then
1591 echo "#### The directory contains: $2 ####"
1592 ls >&2 "$2" || true
1593 elif test -e "$2"; then
1594 echo "#### Complete file: $2 ####"
1595 catfile "$2"
1596 fi
1597 fi
1598 }
1599 msgfailoutputstatfile "$2" "$3"
1600 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1601 shift 3
1602 msgfailoutputstatfile "$2" "$3"
1603 done
1604 echo '#### test output ####'
1605 elif [ "$1" = 'cmp' ]; then
1606 echo >&2
1607 while [ -n "$2" ]; do
1608 echo "#### Complete file: $2 ####"
1609 catfile "$2"
1610 shift
1611 done
1612 echo '#### cmp output ####'
1613 fi
1614 catfile "$OUTPUT"
1615 msgfail "$MSG"
1616 }
1617
1618 testsuccesswithglobalerror() {
1619 local TYPE="$1"
1620 local ERRORS="$2"
1621 shift 2
1622 msggroup "$TYPE"
1623 if [ "$1" = '--nomsg' ]; then
1624 shift
1625 else
1626 msgtest 'Test for successful execution of' "$*"
1627 fi
1628 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output"
1629 if "$@" >"${OUTPUT}" 2>&1; then
1630 if expr match "$1" '^apt.*' >/dev/null; then
1631 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1632 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1633 elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1634 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1635 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1636 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1637 msgpass
1638 else
1639 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1640 fi
1641 else
1642 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1643 fi
1644 elif [ "$TYPE" = 'testsuccesswithnotice' ]; then
1645 if grep -q -E "^N: " "$OUTPUT"; then
1646 msgpass
1647 else
1648 msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@"
1649 fi
1650 else
1651 msgpass
1652 fi
1653 else
1654 msgpass
1655 fi
1656 else
1657 local EXITCODE=$?
1658 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1659 fi
1660 aptautotest "$TYPE" "$@"
1661 msggroup
1662 }
1663 testsuccesswithnotice() {
1664 testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@"
1665 }
1666 testsuccess() {
1667 testsuccesswithglobalerror 'testsuccess' 'NWE' "$@"
1668 }
1669 testwarning() {
1670 msggroup 'testwarning'
1671 if [ "$1" = '--nomsg' ]; then
1672 shift
1673 else
1674 msgtest 'Test for successful execution with warnings of' "$*"
1675 fi
1676 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1677 if "$@" >"${OUTPUT}" 2>&1; then
1678 if expr match "$1" '^apt.*' >/dev/null; then
1679 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1680 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1681 elif grep -q -E '^E: ' "$OUTPUT"; then
1682 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1683 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1684 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1685 else
1686 msgpass
1687 fi
1688 else
1689 msgpass
1690 fi
1691 else
1692 local EXITCODE=$?
1693 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1694 fi
1695 aptautotest 'testwarning' "$@"
1696 msggroup
1697 }
1698 testfailure() {
1699 msggroup 'testfailure'
1700 if [ "$1" = '--nomsg' ]; then
1701 shift
1702 else
1703 msgtest 'Test for failure in execution of' "$*"
1704 fi
1705 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1706 if "$@" >"${OUTPUT}" 2>&1; then
1707 local EXITCODE=$?
1708 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1709 else
1710 local EXITCODE=$?
1711 if expr match "$1" '^apt.*' >/dev/null; then
1712 if [ "$1" = 'aptkey' ]; then
1713 if grep -q " Can't check signature:
1714 BAD signature from
1715 signature could not be verified" "$OUTPUT"; then
1716 msgpass
1717 else
1718 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1719 fi
1720 else
1721 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1722 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1723 elif grep -q -E '==ERROR' "$OUTPUT"; then
1724 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1725 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1726 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1727 else
1728 msgpass
1729 fi
1730 fi
1731 else
1732 msgpass
1733 fi
1734 fi
1735 aptautotest 'testfailure' "$@"
1736 msggroup
1737 }
1738
1739 testreturnstateequal() {
1740 local STATE="$1"
1741 if [ "$STATE" = 'testsuccesswithglobalerror' ]; then
1742 local STATE="$2"
1743 local TYPE="$3"
1744 shift 3
1745 msggroup "${STATE}equal"
1746 if [ "$1" != '--nomsg' ]; then
1747 local CMP="$1"
1748 shift
1749 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1750 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1751 else
1752 local CMP="$2"
1753 shift 2
1754 testsuccesswithglobalerror "$STATE" "$TYPE" "$@"
1755 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1756 fi
1757 else
1758 msggroup "${STATE}equal"
1759 if [ "$2" != '--nomsg' ]; then
1760 local CMP="$2"
1761 shift 2
1762 "$STATE" "$@"
1763 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1764 else
1765 local CMP="$3"
1766 shift 3
1767 "$STATE" --nomsg "$@"
1768 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP"
1769 fi
1770 fi
1771 msggroup
1772 }
1773 testsuccessequal() {
1774 # we compare output, so we know perfectly well about N:
1775 testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@"
1776 }
1777 testwarningequal() {
1778 testreturnstateequal 'testwarning' "$@"
1779 }
1780 testfailureequal() {
1781 testreturnstateequal 'testfailure' "$@"
1782 }
1783
1784 testfailuremsg() {
1785 msggroup 'testfailuremsg'
1786 local CMP="$1"
1787 shift
1788 testfailure "$@"
1789 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1790 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1791 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
1792 testoutputequal "$COMPAREFILE" echo "$CMP"
1793 msggroup
1794 }
1795 testwarningmsg() {
1796 msggroup 'testwarningmsg'
1797 local CMP="$1"
1798 shift
1799 testwarning "$@"
1800 msgtest 'Check that the output of the previous warned command has expected' 'warnings'
1801 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile"
1802 grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true
1803 testoutputequal "$COMPAREFILE" echo "$CMP"
1804 msggroup
1805 }
1806
1807 testfilestats() {
1808 msggroup 'testfilestats'
1809 msgtest "Test that file $1 has $2 $3" "$4"
1810 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1811 msgpass
1812 else
1813 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1814 {
1815 ls -ld "$1" || true
1816 echo -n "stat(1) reports for $2: "
1817 stat --format "$2" "$1" || true
1818 } >"$OUTPUT" 2>&1
1819 msgfailoutput '' "$OUTPUT"
1820 fi
1821 msggroup
1822 }
1823 testaccessrights() {
1824 msggroup 'testaccessrights'
1825 testfilestats "$1" '%a' '=' "$2"
1826 msggroup
1827 }
1828
1829 testwebserverlaststatuscode() {
1830 msggroup 'testwebserverlaststatuscode'
1831 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1832 local STATUS='downloaded/webserverstatus-statusfile.log'
1833 rm -f "$DOWNLOG" "$STATUS"
1834 msgtest 'Test last status code from the webserver was' "$1"
1835 if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1836 msgpass
1837 else
1838 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1839 {
1840 if [ -n "$2" ]; then
1841 shift
1842 echo >&2 '#### Additionally provided output files contain:'
1843 cat >&2 "$@"
1844 fi
1845 echo >&2 '#### Download log of the status code:'
1846 cat >&2 "$DOWNLOG"
1847 } >"$OUTPUT" 2>&1
1848 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
1849 fi
1850 msggroup
1851 }
1852
1853 createlistofkeys() {
1854 local OUTPUT="$1"
1855 shift
1856 while [ -n "$1" ]; do
1857 # gpg 2.1.something starts printing [SC] at some point
1858 if grep -q ' rsa2048/' "$OUTPUT" && grep -qF '[SC]' "$OUTPUT"; then
1859 case "$1" in
1860 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1861 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [SC] [expired: 2013-07-13]';;
1862 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16 [SC]';;
1863 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19 [SC]';;
1864 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18 [SC]';;
1865 *) echo 'UNKNOWN KEY';;
1866 esac
1867 # gpg 2.1 has a slightly different output format
1868 elif grep -q ' rsa2048/' "$OUTPUT"; then
1869 case "$1" in
1870 *Joe*|*Sixpack*) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1871 *Rex*|*Expired*) echo 'pub rsa2048/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1872 *Marvin*|*Paranoid*) echo 'pub rsa2048/528144E2 2011-01-16';;
1873 oldarchive) echo 'pub rsa1024/F68C85A3 2013-12-19';;
1874 newarchive) echo 'pub rsa2048/DBAC8DAE 2010-08-18';;
1875 *) echo 'UNKNOWN KEY';;
1876 esac
1877 else
1878 case "$1" in
1879 *Joe*|*Sixpack*) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1880 *Rex*|*Expired*) echo 'pub 2048R/27CE74F9 2013-07-12 [expired: 2013-07-13]';;
1881 *Marvin*|*Paranoid*) echo 'pub 2048R/528144E2 2011-01-16';;
1882 oldarchive) echo 'pub 1024R/F68C85A3 2013-12-19';;
1883 newarchive) echo 'pub 2048R/DBAC8DAE 2010-08-18';;
1884 *) echo 'UNKNOWN KEY';;
1885 esac
1886 fi
1887 shift
1888 done
1889 }
1890 testaptkeys() {
1891 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output"
1892 if ! aptkey list | grep '^pub' > "$OUTPUT"; then
1893 echo -n > "$OUTPUT"
1894 fi
1895 testfileequal "$OUTPUT" "$(createlistofkeys "$OUTPUT" "$@")"
1896 }
1897
1898 pause() {
1899 echo "STOPPED execution. Press enter to continue"
1900 local IGNORE
1901 read IGNORE
1902 }
1903
1904 listcurrentlistsdirectory() {
1905 {
1906 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1907 stat --format '%U:%G:%a:%n' "$line"
1908 done
1909 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1910 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1911 done
1912 } | sort
1913 }
1914 forallsupportedcompressors() {
1915 rm -f "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
1916 for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do
1917 if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi
1918 "$@" "$COMP"
1919 done
1920 }
1921
1922 ### convenience hacks ###
1923 mkdir() {
1924 # creating some directories by hand is a tedious task, so make it look simple
1925 local PARAMS="$*"
1926 if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then
1927 # only the last directory created by mkdir is effected by the -m !
1928 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1929 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1930 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1931 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1932 if [ "$(id -u)" = '0' ]; then
1933 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1934 fi
1935 else
1936 command mkdir "$@"
1937 fi
1938 }
1939
1940 ### The following tests are run by most test methods automatically to check
1941 ### general things about commands executed without writing the test every time.
1942
1943 aptautotest() {
1944 local TESTCALL="$1"
1945 local CMD="$2"
1946 local FIRSTOPT="$3"
1947 local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')"
1948 if command -v $AUTOTEST >/dev/null; then
1949 shift 3
1950 # save and restore the *.output files from other tests
1951 # as we might otherwise override them in these automatic tests
1952 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1953 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before"
1954 mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1955 $AUTOTEST "$TESTCALL" "$@"
1956 rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1957 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest"
1958 mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp"
1959 fi
1960 }
1961
1962 aptautotest_aptget_update() {
1963 local TESTCALL="$1"
1964 while [ -n "$2" ]; do
1965 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1966 shift
1967 done
1968 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1969 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1970 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1971 # all copied files are properly chmodded
1972 local backupIFS="$IFS"
1973 IFS="$(printf "\n\b")"
1974 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1975 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1976 done
1977 IFS="$backupIFS"
1978 if [ "$TESTCALL" = 'testsuccess' ]; then
1979 # failure cases can retain partial files and such
1980 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1981 fi
1982 }
1983 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1984 aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
1985
1986 testaptautotestnodpkgwarning() {
1987 local TESTCALL="$1"
1988 while [ -n "$2" ]; do
1989 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1990 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
1991 shift
1992 done
1993 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1994 }
1995
1996 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1997 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1998 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1999 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
2000 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
2001 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }